#!/usr/bin/python
# -*- coding: utf-8 -*-

from Functions import *

###############
# Definitions #
###############
p=Parameters.Parameters()
Equation_Type='Diffusion'
Equation_Type='Wave'

###############################
# Initial Gaussian parameters #
###############################
p('tp',-0.1)
p('c',10.0)

#######################
# Defining Parameters #
#######################
p('dx',0.1)
p('xmin',0.0)
p('xmax',2.*p.c)
p('ymin',0.0)
p('ymax',1.0)
p('it',0)
p('dt',p.dx*p.dx/(2.0)*0.1)
p('t',0.0)
p('tmax',20.0)
#p('next_tout',0.0)
p('tout',p.tmax/20)
p('itout',int(p.tout/p.dt)+1)
p('Save',False)
p('Autoscale',False)

##################
# Defining Space #
##################
xs=arange(p.xmin,p.xmax,p.dx)
p('xs',xs)

##########################################
# Defining Equation-dependent parameters #
##########################################
if Equation_Type == 'Diffusion':
   Plot_Gaussian=True
   p('D',1.0)
   psi=Gauss_1D(p)
   p('rhs','ifft_1D(-p.D*p.k*p.k*fft_1D(psi))')

if Equation_Type == 'Wave':
   Plot_Gaussian=False
   p('D',1.0)
   p('v',1.0)
   psi=Gauss_1D(p)
   p('rhs','ifft_1D(-p.v*p.k*1j*fft_1D(psi))')

###################
# Initialize Plot #
###################
Plot_1D(psi,p,Add_Gaussian=Plot_Gaussian)

##############
# Wavenumber #
##############
p('k',Freq_1D(len(p.xs),p.dx)*2.0*pi)

#############################
# Saving/Reading parameters #
#############################
#File='Parameters_1D_%s.dat' % (Equation_Type)
#p.Write_To_File(File)
#p.Read_From_File(File)

while p.it*p.dt < p.tmax:
      psi=Euler_Step(psi,p)
      if (p.it%p.itout) == 0:
         Plot_1D(psi,p,Add_Gaussian=Plot_Gaussian)
